#include <iostream>
#include <algorithm>
#include <set>

using namespace std;

__int64 GetMax(__int64 k)
{
	if (k < 0)
		return 1000000000000;
	__int64 n;
	if (k % 2)
	{
		return (k + 1) / 2;
	}
	else
	{
		n = k / 4;
		--n;
		return __int64(sqrt(n * n + k));
	}
}

__int64 F2(__int64 k)
{
	__int64 n, a, kn2;
	if (k < 0)
	{
		n = __int64(ceil(sqrt(sqrt(k * k)))) - 1;
		while (n * n + k < 0)
			n++;
	}
	else
		n = 0;
	auto m = GetMax(k);
	for (; n < m; n++)
	{
		kn2 = k + n * n;
		a = sqrt(kn2);
		if (a * a == kn2)
			return a;
	}
	return -1;
}

int main(void)
{
	__int64 k, res, sq;
	cin >> k;
#if 0
	for (auto i1 = 0; i1 < 1000; i1++)
	{
		auto
			r1 = F1(i1)
		if (r1 != r2)
			cout << "ahtung " << i1 << " r1, r2 = " << r1 << ", " << r2 << endl;
	}
#endif
	if (k % 2 == 0 && k % 4 != 0)
	{
		cout << "none";
		return 0;
	}
	res = F2(k);
	if (res == -1)
		cout << "none";
	else
		cout << res;
	return 0;
}