#include <iostream>
#include <algorithm>

using namespace std;

__int64 F1(__int64 k)
{
	__int64 n, a, kn2;
	if (k < 0)
	{
		n = int(ceil(sqrt(sqrt(k * k)))) - 1;
		while (n * n < k)
			n++;
	}
	else
		n = max<int>(sqrt(k) - 2, 0);
	for (; n < 10000000; n++)
	{
		kn2 = k + n * n;
		a = sqrt(kn2);
		if (a * a == kn2)
		{
			return a;
		}
	}
	return -1;
}

__int64 F2(__int64 k)
{
	__int64 n;
	__int64 sq = sqrt(k);
	if (sq * sq == k)
		return sq;
	if (k % 2)
	{
		// odd
		int n = (k + 1) / 2;
		return n;
	}
	else
	{
		// even
		if (k % 4 != 0)
		{
			return -1;
		}
		n = k / 4;
		--n;
		return  __int64(sqrt(n * n + k));
	}
}

int main(void)
{
	__int64 k, res, sq;
	cin >> k;
#if 0
	for (auto i1 = 0; i1 < 1000; i1++)
	{
		auto
			r1 = F1(i1),
			r2 = F2(i1);
		//res = r2;
		//for (__int64 i = 0; i < res; i++)
		//{
		//	sq = sqrt(i * i + i1);
		//	if (sq * sq == i * i + i1)
		//	{
		//		res = sq;
		//		break;
		//	}
		//}
		//r2 = res;
		if (r1 != r2)
			cout << "ahtung " << i1 << " r1, r2 = " << r1 << ", " << r2 << endl;
	}
#endif
	if (k % 2 == 0 && k % 4 != 0)
	{
		cout << "none";
		return 0;
	}
	//if (k < 0)
		res = F1(k);
	//else
	//{
	//	res = F2(k);
	//	for (__int64 i = 0; i < res; i++)
	//	{
	//		sq = sqrt(i * i + k);
	//		if (sq * sq == i * i + k)
	//		{
	//			res = sq;
	//			break;
	//		}
	//	}
	//}
	//
	if (res < 0)
		cout << "none";
	else
		cout << res;
	return 0;
}